A visual-heavy introduction to Linear Programming including basic definitions, solution via the Simplex method and the principle of duality.

More problems: https://slama.dev/youtube/linear-programming-in-python/

------------------

Timetable:
0:00 - Introduction
0:26 - Basics
3:44 - Simplex Method
11:47 - Duality
14:01 - Integer Linear Programming
17:31 - Conclusion

------------------

Source code: https://github.com/xiaoxiae/videos/tree/master/18-lopt/

Music (in the order it appears in the video):
► Cases to Rest by Blue Dot Sessions: https://app.sessions.blue/browse/track/139762
► Thannoid by Blue Dot Sessions: https://app.sessions.blue/browse/track/126782
► ZigZag Heart by Blue Dot Sessions: https://app.sessions.blue/browse/track/31462
► Maisie Dreamer by Blue Dot Sessions: https://app.sessions.blue/browse/track/31458
► Night Light by Blue Dot Sessions: https://app.sessions.blue/browse/track/189819

Software used:
► Manim (animation software): https://github.com/ManimCommunity/manim/
► Kdenlive (video cutting): https://kdenlive.org/en/
► ffmpeg (audio/video processing): https://ffmpeg.org/
► OBS (audio/video recording): https://obsproject.com/download
► arecord (audio recording): https://linux.die.net/man/1/arecord
► sox (audio processing): http://sox.sourceforge.net/
► Inkscape (vector image editing): https://inkscape.org/
► Midjourney (image generation): https://www.midjourney.com/app/

Social media:
► Website (for other things I'm up to): https://slama.dev/
► Patreon (if you'd like to support me): https://www.patreon.com/TomasSlama

Thanks to Matěj Kripner, Martin Balko, Lucia Zhang, Václav Rozhoň (@polylog), Kateřina Sulková, Mohit Shrestha, Teo Tuicu and Tomáš Sláma (my dad, not me) for valuable feedback.

------------------

[EN] Gerard Sierksma; Yori Zwols (2015). Linear and Integer Optimization: Theory and Practice
https://www.taylorfrancis.com/books/mono/10.1201/b18378/linear-integer-optimization-gerard-sierksma-gerard-sierksma-yori-zwols

[CZ] Přednáška Jiřího Sgalla: Lineární programování a kombinatorická optimalizace
https://iuuk.mff.cuni.cz/~sgall/vyuka/LP/

[EN] George B. Dantzig (1982): Reminiscences about the origins of linear programming
https://apps.dtic.mil/sti/pdfs/ADA112060.pdf
